## semantik 0.8.3

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2007-2012 (ita)

APPNAME = 'semantik'
VERSION = '0.8.3'

top = '.'

import os, sys, re, time
from waflib import Options, Logs, Configure

def compile_py(task):
	outfile = task.m_outputs[0].abspath()
	f = open(outfile, 'w') # cpython close the file handles for you
	w = f.write
	w('<!DOCTYPE RCC><RCC version="1.0">\n<qresource>\n')
	for k in task.m_inputs:
		w(' <file>')
		w(k.m_name)
		w('</file>\n')
		w('</qresource>\n</RCC>')
	f.close()

def build(bld):

	os.environ['LD_LIBRARY_PATH'] = ':'.join(bld.env['LIBPATH_KDECORE'] + [os.environ.get('LD_LIBRARY_PATH', '')])
	bld.targets = '*' # build all targets by default

	bld(
		features = 'cxx qt4 cxxshlib',
		source = bld.path.ant_glob('src/wp/*.cpp'),
		target = 'nablah',
		use = 'QTCORE QTGUI QTWEBKIT',
		includes='. src src/wp',
		install_path = '${KDE4_LIB_INSTALL_DIR}/')

	bld(features='cxx qt4 cxxprogram pyembed',
		source = bld.path.ant_glob('src/*.cpp src/fig/*.cpp'),
		use = 'QTCORE QTGUI QTXML QTSVG NABLAH KDECORE KIO KDEUI KHTML nablah',
		target = 'src/semantik',
		install_path = '${KDE4_BIN_INSTALL_DIR}/',
		includes = '. src src/fig')

	bld.install_files('${SEMANTIK_DIR}', 'src/sembind.py')

	rt = 'src/templates/'

	glob = bld.path.ant_glob

	bld.install_files('${SEMANTIK_DIR}/flags', glob('src/flags/*.svg'))
	bld.install_files('${TEMPLATE_DIR}', glob(rt+'*.py'))

	bld.install_as('${TEMPLATE_DIR}/waf', 'waf')

	bld.install_files('${TEMPLATE_DIR}/pdflatex', glob(rt+'pdflatex/*'))
	for x in 'html odt odp java'.split():
		bld.install_files('${TEMPLATE_DIR}/' + x, glob(rt+'%s/*' % x))

	for x in "color font inner outer theme".split():
		k = 'beamer/beamermindist/themes/'
		bld.install_files('${TEMPLATE_DIR}/' + k+x, bld.path.ant_glob(rt+k+x+'/*'))

	obj = bld(features='msgfmt', appname = 'semantik', langs=[x.path_from(bld.path).replace('.po', '') for x in bld.path.ant_glob('src/po/*.po')])

	bld.install_files('${TEMPLATE_DIR}/beamer/beamermindist/art/', glob(rt+'beamer/beamermindist/art/*'))
	bld.install_files('${TEMPLATE_DIR}/beamer/beamermindist/', glob(rt+'beamer/beamermindist/*'))
	bld.install_files('${TEMPLATE_DIR}/beamer/', rt+'beamer/main.tex')
	bld.install_files('${TEMPLATE_DIR}/beamer/', rt+'beamer/wscript')

	bld.install_files('${TEMPLATE_DIR}/s5', rt+'s5/index.html')
	bld.install_files('${TEMPLATE_DIR}/s5/ui/default/', glob(rt+'s5/ui/default/*'))
	bld.install_files('${SEMANTIK_DIR}/images', glob('src/images/*.svg'))
	bld.install_files('${FILTER_DIR}/', glob('src/filters/*'))

	bld.install_files('${KDE4_XDG_APPS_INSTALL_DIR}/', 'src/data/semantik.desktop')
	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/128x128/apps/semantik.png', 'src/data/hi128-app-semantik.png')
	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/64x64/apps/semantik.png', 'src/data/hi64-app-semantik.png')
	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/48x48/apps/semantik.png', 'src/data/hi48-app-semantik.png')
	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/32x32/apps/semantik.png', 'src/data/hi32-app-semantik.png')
	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/22x22/apps/semantik.png', 'src/data/hi22-app-semantik.png')
	bld.install_files('${KDE4_DATA_INSTALL_DIR}/semantik', 'src/data/semantikui.rc src/data/tips')

	if bld.cmd in ['install', 'uninstall']:
		lst = os.listdir('src/images')
		lst = [x for x in lst if (x.rfind('hi')>-1)]
		for x in lst:
			els = x.split('-')
			size = els[0][2:]

			uh = els[2].replace('.png', '')
			uh = 'oxygen/%sx%s/actions/%s.png' % (size, size, uh)
			bld.install_as('${KDE4_ICON_INSTALL_DIR}/' + uh, 'src/images/%s' % x)

	bld.add_post_fun(post_build)

def configure(conf):
	def test(system):
		return (sys.platform.lower().rfind(system) > -1)

	err = "Semantik cannot work on %s, please install a Linux system from http://www.opensuse.org"
	if (test('linux')):
		Logs.pprint('GREEN', "You are using Linux, that's good (tm)")
	elif (test('bsd')):
		Logs.pprint('GREEN', "You are using a BSD system, that's good (tm)")
	elif (test('win32') or test('cygwin')):
		conf.fatal(err % "win32")
	elif (test('darwin')):
		conf.fatal(err % "osx")
	elif (test('solaris') or test('sunos')):
		conf.fatal(err % "Sun systems")

	kde_config = os.popen("which kde-config").read().strip()
	if kde_config:
		icons = os.popen('%s --path icon' % kde_config).read().strip()
	else:
		icons = '/usr/share/icons:/usr:/etc/opt/kde3/share/icons/:/opt/kde3/share/icons/:/var/lib/mandriva/kde-profiles/powerpackplus/share/icons/:/usr/share/icons/'
		if not Options.options.icons:
			Logs.warn("For now Semantik uses a few kde icons - if you have problems seeing the icons install kdebase")

	if Options.options.icons:
		icons = Options.options.icons

	conf.load('gcc g++ qt4')
	if not conf.env.CXX: conf.fatal('Semantik requires g++ (compilation only)')
	if not conf.env.QT_LRELEASE: conf.fatal('Semantik requires the program lrelease (from the Qt linguist package? - compilation only)')
	conf.load('python')
	if not conf.env.LIB_QTWEBKIT: conf.fatal('QtWebKit not found - Semantik requires Qt >= 4.4')
	if not conf.env.PYTHON: conf.fatal('Semantik requires Python >= 2.5 (development package for the compilation)')
	conf.check_python_version((2,4,2))
	conf.check_python_headers()
	if not conf.env.PYTHON_VERSION in "2.4 2.5 2.6 2.7".split(): Logs.warn('Bad Python version %s ' % str(conf.env.PYTHON_VERSION))
	#ret = ctx.cmd_output('python-config --cflags').strip().split()

	try:
		conf.load('kde4')
		Logs.pprint('GREEN', "And you even have kde4! we will use it")
	except Configure.ConfigurationError:
		raise
		#Logs.pprint('YELLOW', "kde4 is disabled (missing)")
		conf.fatal('Compiling Semantik requires kde4 -devel')

	conf.env.DEFINES = 'WAF'
	conf.define('ICONS', icons)
	conf.define('VERSION', VERSION)

	conf.env.SEMANTIK_DIR = conf.env.KDE4_DATA_INSTALL_DIR + '/semantik'
	conf.define('SEMANTIK_DIR', conf.env.SEMANTIK_DIR)

	conf.env.TEMPLATE_DIR = conf.env.KDE4_DATA_INSTALL_DIR + '/semantik/templates/'
	conf.define('TEMPLATE_DIR', conf.env.TEMPLATE_DIR)
	conf.env.FILTER_DIR = conf.env.KDE4_DATA_INSTALL_DIR +'/semantik/filters/'
	conf.define('FILTER_DIR', conf.env.FILTER_DIR)
	conf.env.PICDIR = conf.env.KDE4_ICON_INSTALL_DIR #j('share/pixmaps/')
	conf.define('cmd_add_item', 0)
	conf.define('cmd_update_item', 1)
	conf.define('data_root', os.sep)
	conf.define('cmd_remove_item', 2)
	conf.define('cmd_link', 3)
	conf.define('cmd_unlink', 4)
	conf.define('data_outdir', 'tmp')
	conf.define('cmd_select_item', 5)
	conf.define('cmd_sort_item', 6)
	conf.define('cmd_save_data', 7)
	conf.define('cmd_update_colors', 8)
	conf.define('cmd_update_flags', 9)
	conf.define('cmd_open_map', 10)
	conf.define('cmd_pre_view', 11)
	conf.define('cmd_change_data', 12)
	conf.define('cmd_export_item', 13)

	lst = [x for x in conf.path.find_node('src/styles.txt').read().splitlines()]
	buf = []
	for x in lst:
		if not x: continue
		t = x.split('\t')
		buf.append("""xp(x,%d,"%s");yp(x,%d,trUtf8("%s"));""" % (len(buf), t[0], len(buf), t[1].replace('"', '\\"')))
	conf.define('fillglo(x)', ''.join(buf), quote=False)

	lst = [x for x in conf.path.find_node('src/styles_local.txt').read().splitlines()]
	buf = []
	for x in lst:
		if not x: continue
		t = x.split('\t')
		buf.append("""xp(x,%d,"%s");yp(x,%d,trUtf8("%s"));""" % (len(buf), t[0], len(buf), t[1].replace('"', '\\"')))
	conf.define('fillloc(x)', ''.join(buf), quote=False)


	if Options.options.use64:
		conf.env.shlib_INST_DIR = 'lib64'

	conf.env.CXXFLAGS_PYEMBED = [x for x in conf.env.CXXFLAGS_PYEMBED if x != '-g']

	if not 'CXXFLAGS' in os.environ:
		conf.env.CXXFLAGS = '-O2 -pipe -Wall'.split()# -DDEBUG=1 -g'
		#conf.env.CXXFLAGS = ['-g']
	conf.write_config_header('aux.h')

	# the Debian packagers compile with --prefix=/usr and set /etc/ld.so.conf accordingly
	# the rpath is for end users installing into /usr/local/lib only
	sur = '/usr/local'
	if Options.options.prefix[:len(sur)] == sur:
		conf.env.RPATH_NABLAH = '/usr/local/lib'

	conf.define('GAP', 50, quote=False)

def options(opt):
	opt.load('kde4')
	opt.load('qt4')
	opt.load('python')
	opt.add_option('--exe', action='store_true', default=False, help='execute after the compilation (developers)')
	opt.add_option('--icons', action='store', default='', help='icon dirs where to look for kde icons (configuration)')
	opt.add_option('--use64', action='store_true', default=False, help='set the installation into lib+64 (configuration)')

def post_build(bld):
	if bld.cmd == 'install':
		try: bld.exec_command('/sbin/ldconfig 2> /dev/null')
		except: pass
	if Options.options.exe:
		#os.popen('export LD_LIBRARY_PATH=out/default/:$LD_LIBRARY_PATH; PATH=plugins:$PATH out/default/src/semantik')
		bld.exec_command('LD_LIBRARY_PATH=build/:$LD_LIBRARY_PATH build/src/semantik --style plastique', stdout=None, stderr=None)

	return
	# display the graph of header dependencies
	root = os.path.abspath('.')
	def rep(x):
		return str(x).replace(root, '')

	import types
	f = open('me.dot', 'w')
	f.write("digraph G {\n")
	table = bld.depends_on
	for a in table:
		for x in table[a]:
			if type(table[a][x]) is types.ListType:
				for y in table[a][x]:
					f.write('"%s" -> "%s";\n' % (rep(x), rep(y)))
			else:
				f.write('"%s" -> "%s";\n' % (rep(x), rep(table[a][x])))
	f.write('}\n')
	f.close()

	try:
		os.popen('dot -Tpng me.dot -ofoo.png').read()
	except:
		Logs.pprint("the dot program was not found - install graphviz?")
	else:
		Logs.pprint("generated foo.png")

=== src/templates/beamer/wscript ===
#! /usr/bin/python
# -*- mode: python encoding: UTF-8 -*-

'''
run:
$ waf configure
$ waf
$ waf --view

or just:
$ waf --view
'''

VERSION = '0.0.1'
APPNAME = 'the_docs'

top = '.'

import os

def options(opt):
	opt.add_option('--view', action='store_true', default=False, help='View the document')

def configure(conf):
	conf.load('tex')
	cwd = os.getcwd()
	cc = cwd + '/beamermindist/'

	conf.find_program(['okular', 'kpdf', 'xpdf', 'gnome-open'], var='VIEW', mandatory=False)

	lst = []
	for x in "themes/color themes/font themes/inner themes/outer themes/theme art".split():
		lst.append(cc+x)
	u = ":".join(lst)
	conf.env.LATEX = "; export TEXINPUTS=%s:$TEXINPUTS; export GS_OPTIONS=\"-sPAPERSIZE=a4\"; %s" % (u, conf.env.LATEX)

def build(bld) :
	bld(features='tex', type='pdflatex', source='main.tex')

	def view(ctx):
		ctx.exec_command('%s build/main.pdf' % ctx.env.VIEW)

	if bld.env.VIEW and bld.options.view:
		bld.add_post_fun(view)

=== src/templates/java/Makefile ===

SOURCES=Kadapplet.java Mapview.java TextCoord.java

.java.class:
	javac $<

all: Kadapplet.jar

Kadapplet.jar: $(SOURCES) $(SOURCES:.java=.class)
	jar cvf $@ $(SOURCES:.java=.class) pics/

clean:
	\rm -f *.jar *.class

view: Kadapplet.jar
	appletviewer main.html

.SUFFIXES:
.SUFFIXES: .java .class

=== debian/changelog ===
semantik (0.8.3-0ubuntu1) raring; urgency=low

  * New upstream release.
  * debian/patches/kubuntu_01_wscript_log.diff: Refresh.
  * debian/patches/kubuntu_02_menu_entry_fix.diff: Drop, as it is no longer
    necessary.
  * debian/patches/ocaml-link-str.diff: Drop, as it is no longer necessary.
  * debian/patches/qreal-arm.diff: Drop, as it is no longer necessary.
  * debian/rules: Remove broken --want-rpath argument.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 03 Mar 2013 20:58:40 -0500

semantik (0.7.3-0ubuntu7) quantal; urgency=low

  * Fixed typo: "targetted" to "targeted" in debian/control file. 

 -- Bruno Ribeiro da Silva <contato@brunoribeiro.org>  Fri, 01 Jun 2012 08:33:41 -0300

semantik (0.7.3-0ubuntu6) precise; urgency=low

  * Added qreal-arm.diff to fix FTBFS on arm{el,hf}.

 -- Daniel T Chen <crimsun@ubuntu.com>  Fri, 02 Mar 2012 00:10:38 -0500

semantik (0.7.3-0ubuntu5) precise; urgency=low

  * Fix watch file.
  * Simplify debian/rules, adding recommended targets.

 -- Ilya Barygin <randomaction@ubuntu.com>  Sun, 23 Oct 2011 00:36:30 +0400

## semantik 0.8.4

=== wscript ===
--- 
+++ 
@@ -3,12 +3,12 @@
 # Thomas Nagy, 2007-2012 (ita)
 
 APPNAME = 'semantik'
-VERSION = '0.8.3'
+VERSION = '0.8.4'
 
 top = '.'
 
 import os, sys, re, time
-from waflib import Options, Logs, Configure
+from waflib import Options, Logs, Configure, Errors
 
 def compile_py(task):
 	outfile = task.m_outputs[0].abspath()
@@ -51,7 +51,7 @@
 	bld.install_files('${SEMANTIK_DIR}/flags', glob('src/flags/*.svg'))
 	bld.install_files('${TEMPLATE_DIR}', glob(rt+'*.py'))
 
-	bld.install_as('${TEMPLATE_DIR}/waf', 'waf')
+	bld.install_as('${TEMPLATE_DIR}/waf', 'waf', chmod=0755)
 
 	bld.install_files('${TEMPLATE_DIR}/pdflatex', glob(rt+'pdflatex/*'))
 	for x in 'html odt odp java'.split():
@@ -80,17 +80,6 @@
 	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/32x32/apps/semantik.png', 'src/data/hi32-app-semantik.png')
 	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/22x22/apps/semantik.png', 'src/data/hi22-app-semantik.png')
 	bld.install_files('${KDE4_DATA_INSTALL_DIR}/semantik', 'src/data/semantikui.rc src/data/tips')
-
-	if bld.cmd in ['install', 'uninstall']:
-		lst = os.listdir('src/images')
-		lst = [x for x in lst if (x.rfind('hi')>-1)]
-		for x in lst:
-			els = x.split('-')
-			size = els[0][2:]
-
-			uh = els[2].replace('.png', '')
-			uh = 'oxygen/%sx%s/actions/%s.png' % (size, size, uh)
-			bld.install_as('${KDE4_ICON_INSTALL_DIR}/' + uh, 'src/images/%s' % x)
 
 	bld.add_post_fun(post_build)
 
@@ -135,7 +124,7 @@
 	try:
 		conf.load('kde4')
 		Logs.pprint('GREEN', "And you even have kde4! we will use it")
-	except Configure.ConfigurationError:
+	except Errors.ConfigurationError:
 		raise
 		#Logs.pprint('YELLOW', "kde4 is disabled (missing)")
 		conf.fatal('Compiling Semantik requires kde4 -devel')

=== src/templates/pdflatex/wscript ===
#! /usr/bin/python
# -*- mode: python encoding: UTF-8 -*-

'''
run:
$ waf configure
$ waf
$ waf --view

or just:
$ waf --view
'''

import os
from waflib import Options

VERSION = '0.0.1'
APPNAME = 'pdf'

top = '.'
out = 'build'

def options(opts):
	opts.add_option('--view', action='store_true', default=False, help='View the document')

def configure(conf):
	conf.load('tex')
	if not conf.env['PDFLATEX']:
		conf.fatal('install pdflatex!')

	conf.find_program(['okular', 'kpdf', 'xpdf', 'gnome-open'], var='VIEW', mandatory=False)


def build(bld) :
	bld(features='tex', type='pdflatex', source='main.tex')

	def view(ctx):
		ctx.exec_command('%s build/main.pdf' % ctx.env.VIEW)

	if bld.env.VIEW and bld.options.view:
		bld.add_post_fun(view)

=== debian/changelog ===
semantik (0.8.4-0ubuntu2) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 12:12:22 +0000

semantik (0.8.4-0ubuntu1) trusty; urgency=low

  * New upstream release
  * Refresh patch
  * Create debian/docs
  * Bump standards-version to 3.9.5

 -- Jackson Doak <noskcaj@ubuntu.com>  Thu, 21 Nov 2013 18:10:39 +1100

=== debian/control ===
Source: semantik
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Patrick Davies <jpds@ubuntu.com>
Build-Depends: debhelper (>= 7.3.16), libqt4-dev (>= 4:4.5), kdelibs5-dev,
  python (>= 2.3), python-dev (>= 2.3), ocaml-nox, docbook2x,
  pkg-config, libxrender-dev, libqtwebkit-dev
Standards-Version: 3.9.5
Homepage: http://freehackers.org/~tnagy/semantik.html

Package: semantik
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python (>= 2.3)
Replaces: kdissert (<= 1.0.6)
Description: mindmapping-like tool for KDE
 Semantik is a mindmapping-like tool to help students to produce complicated
 documents very quickly and efficiently: presentations, dissertations, thesis,
 reports. While targeted mostly at students, Semantik can also help teachers,
 decision maker, engineers and businessmen.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	PATH=$(PATH):/usr/lib/kde4/bin ./waf configure --prefix=/usr

override_dh_auto_build:
	docbook2x-man debian/semantik.1.docbook
	./waf

override_dh_auto_clean:
	dh_auto_clean
	rm -f semantik.1
	rm -f kde4.pyc
	rm -rf build
	rm -rf .waf*
	rm -f .lock-wscript

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/semantik ./waf -f install
	chmod +x $(CURDIR)/debian/semantik/usr/share/kde4/apps/semantik/filters/*.py

=== debian/watch ===
version=3
http://code.google.com/p/semantik/downloads/list .*/semantik-(\d.*).tar.bz2

## semantik 0.9.5

=== wscript ===
--- 
+++ 
@@ -1,46 +1,45 @@
 #! /usr/bin/env python
 # encoding: utf-8
-# Thomas Nagy, 2007-2012 (ita)
+# Thomas Nagy, 2007-2015 (ita)
 
 APPNAME = 'semantik'
-VERSION = '0.8.4'
+VERSION = '0.9.5'
 
 top = '.'
 
 import os, sys, re, time
-from waflib import Options, Logs, Configure, Errors
-
-def compile_py(task):
-	outfile = task.m_outputs[0].abspath()
-	f = open(outfile, 'w') # cpython close the file handles for you
-	w = f.write
-	w('<!DOCTYPE RCC><RCC version="1.0">\n<qresource>\n')
-	for k in task.m_inputs:
-		w(' <file>')
-		w(k.m_name)
-		w('</file>\n')
-		w('</qresource>\n</RCC>')
-	f.close()
+from waflib import Options, Logs, Configure, Errors, Utils
 
 def build(bld):
 
 	os.environ['LD_LIBRARY_PATH'] = ':'.join(bld.env['LIBPATH_KDECORE'] + [os.environ.get('LD_LIBRARY_PATH', '')])
 	bld.targets = '*' # build all targets by default
 
-	bld(
+	lst = 'src/fig/semd.cpp src/fig/semantik_d_win.cpp src/fig/diagram_document.cpp src/fig/filetree.cpp'
+
+	tg = bld(
 		features = 'cxx qt4 cxxshlib',
-		source = bld.path.ant_glob('src/wp/*.cpp'),
-		target = 'nablah',
-		use = 'QTCORE QTGUI QTWEBKIT',
-		includes='. src src/wp',
+		source = bld.path.ant_glob('src/fig/*.cpp src/base/*.cpp', excl=lst),
+		target = 'semantik',
+		name = 'semlib',
+		vnum = VERSION,
+		use = 'QTCORE QTGUI QTWEBKIT QTXML PYEMBED QTSVG KDECORE KIO KDEUI KHTML',
+		includes='. src src/fig src/base',
 		install_path = '${KDE4_LIB_INSTALL_DIR}/')
 
 	bld(features='cxx qt4 cxxprogram pyembed',
-		source = bld.path.ant_glob('src/*.cpp src/fig/*.cpp'),
-		use = 'QTCORE QTGUI QTXML QTSVG NABLAH KDECORE KIO KDEUI KHTML nablah',
+		source = bld.path.ant_glob('src/*.cpp'),
+		use = 'QTCORE QTGUI QTWEBKIT QTXML QTSVG KDECORE KIO KDEUI KHTML semlib',
 		target = 'src/semantik',
 		install_path = '${KDE4_BIN_INSTALL_DIR}/',
-		includes = '. src src/fig')
+		includes = '. src src/fig src/base')
+
+	bld(features='cxx qt4 cxxprogram pyembed',
+		source = lst,
+		use = 'QTCORE QTGUI QTWEBKIT QTXML QTSVG KDECORE KIO KDEUI KHTML semlib',
+		target = 'src/semantik-d',
+		install_path = '${KDE4_BIN_INSTALL_DIR}/',
+		includes = '. src src/fig src/base')
 
 	bld.install_files('${SEMANTIK_DIR}', 'src/sembind.py')
 
@@ -51,7 +50,7 @@
 	bld.install_files('${SEMANTIK_DIR}/flags', glob('src/flags/*.svg'))
 	bld.install_files('${TEMPLATE_DIR}', glob(rt+'*.py'))
 
-	bld.install_as('${TEMPLATE_DIR}/waf', 'waf', chmod=0755)
+	bld.install_as('${TEMPLATE_DIR}/waf', 'waf', chmod=Utils.O755)
 
 	bld.install_files('${TEMPLATE_DIR}/pdflatex', glob(rt+'pdflatex/*'))
 	for x in 'html odt odp java'.split():
@@ -62,6 +61,8 @@
 		bld.install_files('${TEMPLATE_DIR}/' + k+x, bld.path.ant_glob(rt+k+x+'/*'))
 
 	obj = bld(features='msgfmt', appname = 'semantik', langs=[x.path_from(bld.path).replace('.po', '') for x in bld.path.ant_glob('src/po/*.po')])
+	for x in bld.path.ant_glob('src/po/*.po'):
+		bld.symlink_as('${KDE4_LOCALE_INSTALL_DIR}/%s/LC_MESSAGES/semantik-d.mo' % x.name.strip('.po'), 'semantik.mo')
 
 	bld.install_files('${TEMPLATE_DIR}/beamer/beamermindist/art/', glob(rt+'beamer/beamermindist/art/*'))
 	bld.install_files('${TEMPLATE_DIR}/beamer/beamermindist/', glob(rt+'beamer/beamermindist/*'))
@@ -73,19 +74,30 @@
 	bld.install_files('${SEMANTIK_DIR}/images', glob('src/images/*.svg'))
 	bld.install_files('${FILTER_DIR}/', glob('src/filters/*'))
 
-	bld.install_files('${KDE4_XDG_APPS_INSTALL_DIR}/', 'src/data/semantik.desktop')
-	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/128x128/apps/semantik.png', 'src/data/hi128-app-semantik.png')
-	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/64x64/apps/semantik.png', 'src/data/hi64-app-semantik.png')
-	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/48x48/apps/semantik.png', 'src/data/hi48-app-semantik.png')
-	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/32x32/apps/semantik.png', 'src/data/hi32-app-semantik.png')
-	bld.install_as('${KDE4_ICON_INSTALL_DIR}/hicolor/22x22/apps/semantik.png', 'src/data/hi22-app-semantik.png')
-	bld.install_files('${KDE4_DATA_INSTALL_DIR}/semantik', 'src/data/semantikui.rc src/data/tips')
+	bld.install_files('${KDE4_XDG_APPS_INSTALL_DIR}/', 'src/data/semantik.desktop src/data/semantik-d.desktop')
+	bld.install_files('${MIME_DIR}/', 'src/data/semantik.xml')
+
+	for x in ('', '-d'):
+		bld.install_as('${KDE4_ICON_INSTALL_DIR}/oxygen/128x128/apps/semantik%s.png' % x, 'src/data/hi128-app-semantik%s.png'%x)
+		bld.install_as('${KDE4_ICON_INSTALL_DIR}/oxygen/64x64/apps/semantik%s.png'% x, 'src/data/hi64-app-semantik%s.png'%x)
+		bld.install_as('${KDE4_ICON_INSTALL_DIR}/oxygen/48x48/apps/semantik%s.png'% x, 'src/data/hi48-app-semantik%s.png'%x)
+		bld.install_as('${KDE4_ICON_INSTALL_DIR}/oxygen/32x32/apps/semantik%s.png'% x, 'src/data/hi32-app-semantik%s.png'%x)
+		bld.install_as('${KDE4_ICON_INSTALL_DIR}/oxygen/22x22/apps/semantik%s.png'% x, 'src/data/hi22-app-semantik%s.png'%x)
+
+		#bld(rule="${GZIP} -c ${SRC} > ${TGT}", source='src/data/semantik%s.svg'%x, target='src/data/semantik%s.svgz'%x)
+		bld.install_as('${KDE4_ICON_INSTALL_DIR}/oxygen/scalable/apps/semantik%s.svg'%x, 'src/data/semantik%s.svg'%x)
+
+
+	bld.install_files('${KDE4_DATA_INSTALL_DIR}/semantik', 'src/data/semantikui.rc src/data/semantik-dui.rc src/data/tips')
 
 	bld.add_post_fun(post_build)
+	# update-mime-database /usr/share/mime ?
 
 def configure(conf):
 	def test(system):
 		return (sys.platform.lower().rfind(system) > -1)
+
+	conf.find_program('gzip')
 
 	err = "Semantik cannot work on %s, please install a Linux system from http://www.opensuse.org"
 	if (test('linux')):
@@ -110,7 +122,7 @@
 	if Options.options.icons:
 		icons = Options.options.icons
 
-	conf.load('gcc g++ qt4')
+	conf.load('compiler_c compiler_cxx qt4')
 	if not conf.env.CXX: conf.fatal('Semantik requires g++ (compilation only)')
 	if not conf.env.QT_LRELEASE: conf.fatal('Semantik requires the program lrelease (from the Qt linguist package? - compilation only)')
 	conf.load('python')
@@ -133,7 +145,10 @@
 	conf.define('ICONS', icons)
 	conf.define('VERSION', VERSION)
 
+	kdeconfig = conf.find_program('kde4-config')
+	prefix = conf.cmd_and_log(Utils.to_list(kdeconfig) + ['--prefix']).strip()
 	conf.env.SEMANTIK_DIR = conf.env.KDE4_DATA_INSTALL_DIR + '/semantik'
+	conf.env.MIME_DIR = prefix + '/share/mime/packages'
 	conf.define('SEMANTIK_DIR', conf.env.SEMANTIK_DIR)
 
 	conf.env.TEMPLATE_DIR = conf.env.KDE4_DATA_INSTALL_DIR + '/semantik/templates/'
@@ -175,14 +190,11 @@
 	conf.define('fillloc(x)', ''.join(buf), quote=False)
 
 
-	if Options.options.use64:
-		conf.env.shlib_INST_DIR = 'lib64'
-
 	conf.env.CXXFLAGS_PYEMBED = [x for x in conf.env.CXXFLAGS_PYEMBED if x != '-g']
 
 	if not 'CXXFLAGS' in os.environ:
 		conf.env.CXXFLAGS = '-O2 -pipe -Wall'.split()# -DDEBUG=1 -g'
-		#conf.env.CXXFLAGS = ['-g']
+		#conf.env.CXXFLAGS = ['-g', '-Wall']
 	conf.write_config_header('aux.h')
 
 	# the Debian packagers compile with --prefix=/usr and set /etc/ld.so.conf accordingly
@@ -194,46 +206,28 @@
 	conf.define('GAP', 50, quote=False)
 
 def options(opt):
+	opt.load('compiler_c compiler_cxx')
 	opt.load('kde4')
 	opt.load('qt4')
-	opt.load('python')
-	opt.add_option('--exe', action='store_true', default=False, help='execute after the compilation (developers)')
+	opt.load('python ')
+	opt.add_option('--exe', action='store_true', default=False, help='execute semantik after the compilation (developers)')
+	opt.add_option('--ddd', action='store_true', default=False, help='execute semantik-d after the compilation (developers)')
 	opt.add_option('--icons', action='store', default='', help='icon dirs where to look for kde icons (configuration)')
-	opt.add_option('--use64', action='store_true', default=False, help='set the installation into lib+64 (configuration)')
+	opt.add_option('--nomimes', action='store_true', default=False, help='do not run update-mime-database when installing')
+	opt.add_option('--noldconfig', action='store_true', default=False, help='do not run lconfig when installing')
 
 def post_build(bld):
 	if bld.cmd == 'install':
-		try: bld.exec_command('/sbin/ldconfig 2> /dev/null')
-		except: pass
+		if not Options.options.noldconfig:
+			try: bld.exec_command('/sbin/ldconfig 2> /dev/null')
+			except Exception: pass
+		if not Options.options.nomimes:
+			try: bld.exec_command('update-mime-database %s' % os.path.split(bld.env.MIME_DIR)[0])
+			except Exception: pass
+
 	if Options.options.exe:
 		#os.popen('export LD_LIBRARY_PATH=out/default/:$LD_LIBRARY_PATH; PATH=plugins:$PATH out/default/src/semantik')
 		bld.exec_command('LD_LIBRARY_PATH=build/:$LD_LIBRARY_PATH build/src/semantik --style plastique', stdout=None, stderr=None)
-
-	return
-	# display the graph of header dependencies
-	root = os.path.abspath('.')
-	def rep(x):
-		return str(x).replace(root, '')
-
-	import types
-	f = open('me.dot', 'w')
-	f.write("digraph G {\n")
-	table = bld.depends_on
-	for a in table:
-		for x in table[a]:
-			if type(table[a][x]) is types.ListType:
-				for y in table[a][x]:
-					f.write('"%s" -> "%s";\n' % (rep(x), rep(y)))
-			else:
-				f.write('"%s" -> "%s";\n' % (rep(x), rep(table[a][x])))
-	f.write('}\n')
-	f.close()
-
-	try:
-		os.popen('dot -Tpng me.dot -ofoo.png').read()
-	except:
-		Logs.pprint("the dot program was not found - install graphviz?")
-	else:
-		Logs.pprint("generated foo.png")
-
-
+	if Options.options.ddd:
+		bld.exec_command('LD_LIBRARY_PATH=build/:$LD_LIBRARY_PATH build/src/semantik-d --style plastique', stdout=None, stderr=None)
+

=== src/templates/beamer/wscript ===
--- 
+++ 
@@ -38,7 +38,7 @@
 	bld(features='tex', type='pdflatex', source='main.tex')
 
 	def view(ctx):
-		ctx.exec_command('%s build/main.pdf' % ctx.env.VIEW)
+		ctx.exec_command(ctx.env.VIEW + ['build/main.pdf'])
 
 	if bld.env.VIEW and bld.options.view:
 		bld.add_post_fun(view)

=== src/templates/pdflatex/wscript ===
--- 
+++ 
@@ -35,7 +35,7 @@
 	bld(features='tex', type='pdflatex', source='main.tex')
 
 	def view(ctx):
-		ctx.exec_command('%s build/main.pdf' % ctx.env.VIEW)
+		ctx.exec_command(ctx.env.VIEW + ['build/main.pdf'])
 
 	if bld.env.VIEW and bld.options.view:
 		bld.add_post_fun(view)

=== debian/changelog ===
semantik (0.9.5-0ubuntu2) bionic; urgency=medium

  * Rebuild against new OCaml ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 08:16:06 +0200

semantik (0.9.5-0ubuntu1) zesty; urgency=medium

  * New upstream release.
  * Refresh existing patch.
  * Use dh 10.
  * Bump compat to 9.
  * Bump standards to 3.9.8
  * Bump python deps to 2.7
  * Update watch file to track github.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Fri, 06 Jan 2017 12:36:35 +0530

=== debian/control ===
Source: semantik
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Patrick Davies <jpds@ubuntu.com>
Build-Depends: debhelper (>= 10), libqt4-dev (>= 4:4.5), kdelibs5-dev,
  python (>= 2.7), python-dev (>= 2.7), ocaml-nox, docbook2x,
  pkg-config, libxrender-dev, libqtwebkit-dev
Standards-Version: 3.9.8
Homepage: http://freehackers.org/~tnagy/semantik.html

Package: semantik
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python (>= 2.7)
Replaces: kdissert (<= 1.0.6)
Description: mindmapping-like tool for KDE
 Semantik is a mindmapping-like tool to help students to produce complicated
 documents very quickly and efficiently: presentations, dissertations, thesis,
 reports. While targeted mostly at students, Semantik can also help teachers,
 decision maker, engineers and businessmen.

=== debian/watch ===
version=4
https://github.com/ita1024/semantik/tags .*/?(\d\S+)\.tar\.gz
